//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

// FileDetailDialog.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "FileDetailDialog.h"
#include "otherfunctions.h"


// CFileDetailDialog dialog

IMPLEMENT_DYNAMIC(CFileDetailDialog, CDialog)
CFileDetailDialog::CFileDetailDialog(CPartFile* file)
	: CDialog(CFileDetailDialog::IDD, 0)
{
	m_file = file;
}

CFileDetailDialog::~CFileDetailDialog()
{
}

void CFileDetailDialog::OnTimer(UINT nIDEvent) {
	UpdateData();
}

void CFileDetailDialog::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BOOL CFileDetailDialog::OnInitDialog(){
	CDialog::OnInitDialog();
	Localize();
	m_timer=SetTimer(301, 5000, 0);
	UpdateData();

	return true;
}

void CFileDetailDialog::UpdateData(){
	char buffer[100];

	GetDlgItem(IDC_FNAME)->SetWindowText(m_file->GetFileName());
	GetDlgItem(IDC_METFILE)->SetWindowText(m_file->GetFullName());

	buffer[0] = 0;
	for (uint16 i = 0;i != 16;i++) // hmm I wonder if there is a standart function for this
		sprintf(buffer,"%s%02X",buffer,m_file->GetFileHash()[i]);
	GetDlgItem(IDC_FHASH)->SetWindowText(buffer);

	CastItoXBytes(m_file->GetFileSize(),buffer);
	sprintf(buffer,"%s",buffer);
	GetDlgItem(IDC_FSIZE)->SetWindowText(buffer);

	GetDlgItem(IDC_PFSTATUS)->SetWindowText(m_file->getPartfileStatus());
	
	sprintf(buffer,"%i",m_file->GetPartCount());
	GetDlgItem(IDC_PARTCOUNT)->SetWindowText(buffer);

	CastItoXBytes(m_file->GetTransfered(),buffer);
	GetDlgItem(IDC_TRANSFERED)->SetWindowText(buffer);

	CastItoXBytes(m_file->GetCompletedSize(),buffer);
	GetDlgItem(IDC_COMPLSIZE)->SetWindowText(buffer);

	sprintf(buffer,"%i ",m_file->GetPercentCompleted());
	GetDlgItem(IDC_PROCCOMPL)->SetWindowText(buffer+GetResString(IDS_PROCDONE));

	sprintf(buffer,"%.2f kB/s",(float)m_file->GetDatarate()/1024);
	GetDlgItem(IDC_DATARATE)->SetWindowText(buffer);

	sprintf(buffer,"%i",m_file->GetSourceCount());
	GetDlgItem(IDC_SOURCECOUNT)->SetWindowText(buffer);
	sprintf(buffer,"%i",m_file->GetTransferingSrcCount());
	GetDlgItem(IDC_SOURCECOUNT2)->SetWindowText(buffer);


}

void CFileDetailDialog::OnDestroy() {
	 if (m_timer) KillTimer(m_timer);
}

BEGIN_MESSAGE_MAP(CFileDetailDialog, CDialog)
	ON_WM_TIMER()
	ON_WM_DESTROY()
END_MESSAGE_MAP()


// CFileDetailDialog message handlers

void CFileDetailDialog::Localize(){
	GetDlgItem(IDC_FD_X0)->SetWindowText(GetResString(IDS_FD_GENERAL));
	GetDlgItem(IDC_FD_X1)->SetWindowText(GetResString(IDS_FD_NAME));
	GetDlgItem(IDC_FD_X2)->SetWindowText(GetResString(IDS_FD_MET));
	GetDlgItem(IDC_FD_X3)->SetWindowText(GetResString(IDS_FD_HASH));
	GetDlgItem(IDC_FD_X4)->SetWindowText(GetResString(IDS_FD_SIZE));
	GetDlgItem(IDC_FD_X5)->SetWindowText(GetResString(IDS_FD_STATUS));
	GetDlgItem(IDC_FD_X6)->SetWindowText(GetResString(IDS_FD_TRANSFER));
	GetDlgItem(IDC_FD_X7)->SetWindowText(GetResString(IDS_FD_SOURCES));
	GetDlgItem(IDC_FD_X10)->SetWindowText(GetResString(IDS_FD_TRANSI));
	GetDlgItem(IDC_FD_X9)->SetWindowText(GetResString(IDS_FD_PARTS));
	GetDlgItem(IDC_FD_X14)->SetWindowText(GetResString(IDS_FD_TRANS));
	GetDlgItem(IDC_FD_X12)->SetWindowText(GetResString(IDS_FD_COMPSIZE));
	GetDlgItem(IDC_FD_X13)->SetWindowText(GetResString(IDS_FD_DATARATE));
	GetDlgItem(IDOK)->SetWindowText(GetResString(IDS_FD_CLOSE));
	SetWindowText(GetResString(IDS_FD_TITLE));
}