//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.


// PreferencesWnd.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PreferencesWnd.h"
#include "objbase.h"
#include "Shlobj.h"

// CPreferencesWnd dialog

IMPLEMENT_DYNAMIC(CPreferencesWnd, CDialog)
CPreferencesWnd::CPreferencesWnd(CWnd* pParent /*=NULL*/)
	: CResizableDialog(CPreferencesWnd::IDD, pParent)
{
}

CPreferencesWnd::~CPreferencesWnd()
{
}

void CPreferencesWnd::DoDataExchange(CDataExchange* pDX){
	CResizableDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_SHARESELECTOR, m_ShareSelector);
	DDX_Control(pDX, IDC_LANGS, m_language);
}

bool CPreferencesWnd::Create(UINT nIDTemplate,CPreferences* in_prefs){
	app_prefs = in_prefs;
	return CResizableDialog::Create(nIDTemplate);
}

BOOL CPreferencesWnd::OnInitDialog(){
	CResizableDialog::OnInitDialog();
	Localize();
	((CEdit*)GetDlgItem(IDC_NICK))->SetLimitText(49);
	((CEdit*)GetDlgItem(IDC_INCFILES))->SetLimitText(509);
	((CEdit*)GetDlgItem(IDC_TEMPFILES))->SetLimitText(509);

	m_language.SetItemData(m_language.AddString("English"),LANG_ENGLISH);
	m_language.SetItemData(m_language.AddString("German"),LANG_GERMAN);
	m_language.SetItemData(m_language.AddString("French"),LANG_FRENCH);
	m_language.SetItemData(m_language.AddString("Danish"),LANG_DANISH);
	m_language.SetItemData(m_language.AddString("Spanish"),LANG_SPANISH);
	m_language.SetItemData(m_language.AddString("Dutch"),LANG_DUTCH);
	m_language.SetItemData(m_language.AddString("Russian"),LANG_RUSSIAN);
	m_language.SetItemData(m_language.AddString("Slovenian"),LANG_SLOVENIAN);
	m_language.SetItemData(m_language.AddString("Chinese (simplified)"),LANG_CHINESE);
	m_language.SetItemData(m_language.AddString("Lithuanian"),LANG_LITHUANIAN);

	LoadSettings();

	ShowSizeGrip(FALSE);
	AddAnchor(IDC_APPLY,BOTTOM_RIGHT);
	AddAnchor(IDC_BUTTON3,BOTTOM_RIGHT);
	return true;
}
void CPreferencesWnd::LoadSettings(){

	GetDlgItem(IDC_NICK)->SetWindowText(app_prefs->prefs->nick);
	GetDlgItem(IDC_INCFILES)->SetWindowText(app_prefs->prefs->incomingdir);
	GetDlgItem(IDC_TEMPFILES)->SetWindowText(app_prefs->prefs->tempdir);

	if( app_prefs->prefs->deadserver)
		CheckDlgButton(IDC_REMOVEDEAD,1);
	else
		CheckDlgButton(IDC_REMOVEDEAD,0);

	if (app_prefs->prefs->transferDoubleclick)
		CheckDlgButton(IDC_DBLCLICK,1);
	else
		CheckDlgButton(IDC_DBLCLICK,0);

	if (app_prefs->prefs->scorsystem)
		CheckDlgButton(IDC_SCORE,1);
	else
		CheckDlgButton(IDC_SCORE,0);
	if (app_prefs->prefs->reconnect)
		CheckDlgButton(IDC_RECONN,1);
	else
		CheckDlgButton(IDC_RECONN,0);

	if (app_prefs->prefs->ICH)
		CheckDlgButton(IDC_ICH,1);
	else
		CheckDlgButton(IDC_ICH,0);

	if (app_prefs->prefs->autoserverlist)
		CheckDlgButton(IDC_AUTOSERVER,1);
	else
		CheckDlgButton(IDC_AUTOSERVER,0);

	if (app_prefs->prefs->updatenotify)
		CheckDlgButton(IDC_NOTIFY,1);
	else
		CheckDlgButton(IDC_NOTIFY,0);

	if (app_prefs->prefs->mintotray)
		CheckDlgButton(IDC_MINTRAY,1);
	else
		CheckDlgButton(IDC_MINTRAY,0);

	if (app_prefs->prefs->autoconnect)
		CheckDlgButton(IDC_AUTOCONNECT,1);
	else
		CheckDlgButton(IDC_AUTOCONNECT,0);
	if (app_prefs->prefs->addserversfromserver)
		CheckDlgButton(IDC_UPDATESERVERCONNECT, 1);
	else
		CheckDlgButton(IDC_UPDATESERVERCONNECT, 0);
	if (app_prefs->prefs->addserversfromclient)
		CheckDlgButton(IDC_UPDATESERVERCLIENT, 1);
	else
		CheckDlgButton(IDC_UPDATESERVERCLIENT, 0);

	if (app_prefs->prefs->beepOnError)
		CheckDlgButton(IDC_BEEPER,1);
	else
		CheckDlgButton(IDC_BEEPER,0);
	if (app_prefs->prefs->confirmExit)
		CheckDlgButton(IDC_EXIT,1);
	else
		CheckDlgButton(IDC_EXIT,0);

	if (app_prefs->prefs->splashscreen)
		CheckDlgButton(IDC_SPLASHON,1);
	else
		CheckDlgButton(IDC_SPLASHON,0);
	if (app_prefs->prefs->filerBadIP)
		CheckDlgButton(IDC_FILTER,1);
	else
		CheckDlgButton(IDC_FILTER,0);
	if(app_prefs->prefs->bringtoforeground)
		CheckDlgButton(IDC_BRINGTOFOREGROUND,1);
	else
		CheckDlgButton(IDC_BRINGTOFOREGROUND,0);

	char buffer[20];
	memset(&buffer,0,20);

	if (app_prefs->prefs->maxupload == 0xFFFF)
		GetDlgItem(IDC_MAXUP)->SetWindowText("0");
	else{
		itoa(app_prefs->prefs->maxupload,buffer,10);
		GetDlgItem(IDC_MAXUP)->SetWindowText(buffer);
	}
	if (app_prefs->prefs->maxdownload == 0xFFFF)
		GetDlgItem(IDC_MAXDOWN)->SetWindowText("0");
	else{
		itoa(app_prefs->prefs->maxdownload,buffer,10);
		GetDlgItem(IDC_MAXDOWN)->SetWindowText(buffer);
	}
	if(app_prefs->prefs->maxsourceperfile == 0xFFFF) 
		GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText("200"); 
	else{
		itoa(app_prefs->prefs->maxsourceperfile,buffer,10); 
		GetDlgItem(IDC_MAXSOURCEPERFILE)->SetWindowText(buffer); 
	}
	// Auto completes this option until advanced options
	app_prefs->prefs->maxsourceperfilesoft = app_prefs->prefs->maxsourceperfile * .9;
	//

	if(app_prefs->prefs->maxsourceperfilesoft == 0xFFFF)
		GetDlgItem(IDC_MAXSOURCEPERFILESOFT)->SetWindowText("0"); 
	else{
		itoa(app_prefs->prefs->maxsourceperfilesoft,buffer,10); 
		GetDlgItem(IDC_MAXSOURCEPERFILESOFT)->SetWindowText(buffer); 
	}

	itoa(app_prefs->prefs->maxconnections,buffer,10);
	GetDlgItem(IDC_MAXCON)->SetWindowText(buffer);
	itoa(app_prefs->prefs->port,buffer,10);
	GetDlgItem(IDC_PORT)->SetWindowText(buffer);

	itoa(app_prefs->prefs->maxGraphDownloadRate ,buffer,10);
	GetDlgItem(IDC_DOWNLOAD_CAP)->SetWindowText(buffer);
	itoa(app_prefs->prefs->maxGraphUploadRate,buffer,10);
	GetDlgItem(IDC_UPLOAD_CAP)->SetWindowText(buffer);

	itoa(app_prefs->prefs->deadserverretries,buffer,10);
	GetDlgItem(IDC_SERVERRETRIES)->SetWindowText(buffer);

	m_ShareSelector.SetSharedDirectories(&app_prefs->shareddir_list);
	for (int i = 0; i != m_language.GetCount();i++){
		if (m_language.GetItemData(i) == app_prefs->GetLanguageID())
			m_language.SetCurSel(i);
	}

	switch(app_prefs->prefs->m_iSeeShares){
		case 0:
			this->CheckDlgButton(IDC_SEESHARE1,1);
			break;
		case 1:
			this->CheckDlgButton(IDC_SEESHARE2,1);
			break;
		default:
			this->CheckDlgButton(IDC_SEESHARE3,1);
			break;
	}
	itoa(app_prefs->prefs->m_iToolDelayTime, buffer, 10);
	GetDlgItem(IDC_TOOLTIPDELAY)->SetWindowText(buffer);
}

BEGIN_MESSAGE_MAP(CPreferencesWnd, CResizableDialog)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_APPLY, OnBnClickedApply)
	ON_BN_CLICKED(IDC_BROWSE1, OnBnClickedBrowse1)
	ON_BN_CLICKED(IDC_BROWSE2, OnBnClickedBrowse2)
END_MESSAGE_MAP()


// CPreferencesWnd message handlers


void CPreferencesWnd::OnBnClickedButton3(){
	LoadSettings();
}

void CPreferencesWnd::OnBnClickedApply(){
	char buffer[510];
	int lastmaxgu=app_prefs->prefs->maxGraphUploadRate;
	int lastmaxgd=app_prefs->prefs->maxGraphDownloadRate;

	if (GetDlgItem(IDC_NICK)->GetWindowTextLength()){
		GetDlgItem(IDC_NICK)->GetWindowText(buffer,34);
		strcpy(app_prefs->prefs->nick,buffer);
	}
	if (GetDlgItem(IDC_INCFILES)->GetWindowTextLength()){
		GetDlgItem(IDC_INCFILES)->GetWindowText(buffer,509);
		strcpy(app_prefs->prefs->incomingdir,buffer);
	}
	if (GetDlgItem(IDC_TEMPFILES)->GetWindowTextLength()){
		GetDlgItem(IDC_TEMPFILES)->GetWindowText(buffer,509);
		strcpy(app_prefs->prefs->tempdir,buffer);
	}
	if (GetDlgItem(IDC_MAXUP)->GetWindowTextLength()){
		GetDlgItem(IDC_MAXUP)->GetWindowText(buffer,20);
		app_prefs->prefs->maxupload = (atoi(buffer))? atoi(buffer):0xFFFF;
	}
	if (GetDlgItem(IDC_MAXDOWN)->GetWindowTextLength()){
		GetDlgItem(IDC_MAXDOWN)->GetWindowText(buffer,20);
		app_prefs->prefs->maxdownload = (atoi(buffer))? atoi(buffer):0xFFFF;
	}
	if (GetDlgItem(IDC_MAXCON)->GetWindowTextLength()){
		GetDlgItem(IDC_MAXCON)->GetWindowText(buffer,20);
		app_prefs->prefs->maxconnections = (atoi(buffer))? atoi(buffer):500;
	}
	if (GetDlgItem(IDC_PORT)->GetWindowTextLength()){
		GetDlgItem(IDC_PORT)->GetWindowText(buffer,20);
		app_prefs->prefs->port = (atoi(buffer))? atoi(buffer):4662;
	}
	// Auto completes this option until advanced options
	if (GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowTextLength()){ 
		GetDlgItem(IDC_MAXSOURCEPERFILE)->GetWindowText(buffer,20); 
		app_prefs->prefs->maxsourceperfile = (atoi(buffer))? atoi(buffer):1;
	} 
	app_prefs->prefs->maxsourceperfilesoft = app_prefs->prefs->maxsourceperfile * .9;
	//
	if (GetDlgItem(IDC_MAXSOURCEPERFILESOFT)->GetWindowTextLength()){ 
		GetDlgItem(IDC_MAXSOURCEPERFILESOFT)->GetWindowText(buffer,20);
		app_prefs->prefs->maxsourceperfilesoft = (atoi(buffer))? atoi(buffer):0xFFFF; 
	} 

	// <<--2002-09-26
	if (GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowTextLength()){ 
		GetDlgItem(IDC_DOWNLOAD_CAP)->GetWindowText(buffer,20); //<<--
		app_prefs->prefs->maxGraphDownloadRate = (atoi(buffer))? atoi(buffer):100; //<<--
	} //<<--
	if (GetDlgItem(IDC_UPLOAD_CAP)->GetWindowTextLength()){ //<<--
		GetDlgItem(IDC_UPLOAD_CAP)->GetWindowText(buffer,20); //<<--
		app_prefs->prefs->maxGraphUploadRate = (atoi(buffer))? atoi(buffer):25; //<<--
	}

	if (GetDlgItem(IDC_SERVERRETRIES)->GetWindowTextLength()){
		GetDlgItem(IDC_SERVERRETRIES)->GetWindowText(buffer,20);
		app_prefs->prefs->deadserverretries = (atoi(buffer))? atoi(buffer):5;
	}

	if (m_language.GetCurSel() != CB_ERR){
		uint8 byNewLang =  m_language.GetItemData(m_language.GetCurSel());
		if (app_prefs->prefs->languageID != byNewLang){
			SetThreadLocale(MAKELANGID(byNewLang,SUBLANG_DEFAULT));
			theApp.emuledlg->preferenceswnd.Localize();
			theApp.emuledlg->statisticswnd.Localize();
			theApp.emuledlg->transferwnd.Localize();
			theApp.emuledlg->searchwnd.Localize();
			theApp.emuledlg->sharedfileswnd.Localize();
			theApp.emuledlg->chatwnd.Localize();
			theApp.emuledlg->Localize();
		}
		app_prefs->prefs->languageID= byNewLang;
	}
	
	app_prefs->prefs->scorsystem = (int8)IsDlgButtonChecked(IDC_SCORE);
	app_prefs->prefs->deadserver = (int8)IsDlgButtonChecked(IDC_REMOVEDEAD);
	app_prefs->prefs->reconnect = (int8)IsDlgButtonChecked(IDC_RECONN);
	app_prefs->prefs->autoserverlist = (int8)IsDlgButtonChecked(IDC_AUTOSERVER);
	app_prefs->prefs->ICH = (int8)IsDlgButtonChecked(IDC_ICH);
	app_prefs->prefs->updatenotify = (int8)IsDlgButtonChecked(IDC_NOTIFY);
	app_prefs->prefs->mintotray = (int8)IsDlgButtonChecked(IDC_MINTRAY);
	app_prefs->prefs->autoconnect = (int8)IsDlgButtonChecked(IDC_AUTOCONNECT);
	app_prefs->prefs->addserversfromclient = (int8)IsDlgButtonChecked(IDC_UPDATESERVERCLIENT);
	app_prefs->prefs->addserversfromserver = (int8)IsDlgButtonChecked(IDC_UPDATESERVERCONNECT);
	app_prefs->prefs->beepOnError= (int8)IsDlgButtonChecked(IDC_BEEPER);
	app_prefs->prefs->confirmExit= (int8)IsDlgButtonChecked(IDC_EXIT);
	app_prefs->prefs->splashscreen = (int8)IsDlgButtonChecked(IDC_SPLASHON);
	app_prefs->prefs->filerBadIP = (int8)IsDlgButtonChecked(IDC_FILTER);
	app_prefs->prefs->bringtoforeground = (int8)IsDlgButtonChecked(IDC_BRINGTOFOREGROUND);
	app_prefs->prefs->transferDoubleclick= (int8)IsDlgButtonChecked(IDC_DBLCLICK);

//	if (IsDlgButtonChecked(IDC_RADIO1))
//		app_prefs->prefs->deadserver = 1;
//	else
//		app_prefs->prefs->deadserver = 2;

	if (IsDlgButtonChecked(IDC_SEESHARE1))
		app_prefs->prefs->m_iSeeShares = 0;
	else if (IsDlgButtonChecked(IDC_SEESHARE2))
		app_prefs->prefs->m_iSeeShares = 1;
	else
		app_prefs->prefs->m_iSeeShares = 2;

	GetDlgItem(IDC_TOOLTIPDELAY)->GetWindowText(buffer,20);
	if (atoi(buffer) > 60)
		app_prefs->prefs->m_iToolDelayTime = 60;
	else
		app_prefs->prefs->m_iToolDelayTime = atoi(buffer);
	theApp.emuledlg->transferwnd.m_ttip.SetDelayTime(TTDT_INITIAL, theApp.glob_prefs->GetToolTipDelay()*1000);

	if (app_prefs->prefs->deadserverretries<1) app_prefs->prefs->deadserverretries=5;

	// change O-Meter-Ranges only if necessary
	if (lastmaxgu!=app_prefs->prefs->maxGraphUploadRate) 
		theApp.emuledlg->statisticswnd.SetARange(false,app_prefs->prefs->maxGraphUploadRate);
	if (lastmaxgd!=app_prefs->prefs->maxGraphDownloadRate)
			theApp.emuledlg->statisticswnd.SetARange(true,app_prefs->prefs->maxGraphDownloadRate);
	// <<--2002-09-26

	app_prefs->shareddir_list.RemoveAll();
	m_ShareSelector.GetSharedDirectories(&app_prefs->shareddir_list);
	theApp.sharedfiles->Reload();
	app_prefs->Save();
	theApp.emuledlg->transferwnd.downloadlistctrl.SetStyle();
	this->LoadSettings();
}


bool CPreferencesWnd::SelectDir(char* outdir, char* titletext){
	CoInitialize(0);
	bool done;
	char* buffer = new char[MAX_PATH];
	BROWSEINFO bi = {GetSafeHwnd(),0,buffer,titletext,BIF_VALIDATE|BIF_NEWDIALOGSTYLE|BIF_RETURNONLYFSDIRS,0,0,0};
	LPITEMIDLIST pidl = SHBrowseForFolder(&bi);
	delete[] buffer;
	done = SHGetPathFromIDList(pidl,outdir);
	LPMALLOC ppMalloc;
	if (SHGetMalloc(&ppMalloc) == NOERROR)
		ppMalloc->Free(pidl);
	CoUninitialize();
	return done;
}
void CPreferencesWnd::OnBnClickedBrowse1(){
	char buffer[MAX_PATH];
	CString temp;
	temp=GetResString(IDS_SELECTINCOMINGDIR);
	if (SelectDir(buffer,temp.GetBuffer()))
		GetDlgItem(IDC_INCFILES)->SetWindowText(buffer);
}

void CPreferencesWnd::OnBnClickedBrowse2(){
	char buffer[MAX_PATH];
	CString temp;
	temp=GetResString(IDS_SELECTTEMPDIR);
	if (SelectDir(buffer,temp.GetBuffer()))
		GetDlgItem(IDC_TEMPFILES)->SetWindowText(buffer);
}

void CPreferencesWnd::Localize(){
	GetDlgItem(IDC_STATICFIX1)->SetWindowText(GetResString(IDS_PW_GENERAL));
	GetDlgItem(IDC_DIRS)->SetWindowText(GetResString(IDS_PW_DIR));
	GetDlgItem(IDC_TRAFFIC_TEXT4)->SetWindowText(GetResString(IDS_PW_NICK));
	GetDlgItem(IDC_TRAFFIC_TEXT10)->SetWindowText(GetResString(IDS_PW_INCOMING));
	GetDlgItem(IDC_TRAFFIC_TEXT11)->SetWindowText(GetResString(IDS_PW_TEMP));
	GetDlgItem(IDC_BROWSE1)->SetWindowText(GetResString(IDS_PW_BROWSE));
	GetDlgItem(IDC_BROWSE2)->SetWindowText(GetResString(IDS_PW_BROWSE));
	GetDlgItem(IDC_TRAFFIC_TEXT12)->SetWindowText(GetResString(IDS_PW_SHARED));
	GetDlgItem(IDC_CONNTITLE)->SetWindowText(GetResString(IDS_PW_CONNECTION));
	GetDlgItem(IDC_STATIC22)->SetWindowText(GetResString(IDS_PW_DOWNC));
	GetDlgItem(IDC_TRAFFIC_TEXT3)->SetWindowText(GetResString(IDS_PW_DOWNL));
	GetDlgItem(IDC_STATIC23)->SetWindowText(GetResString(IDS_PW_UPC));
	GetDlgItem(IDC_TRAFFIC_TEXT2)->SetWindowText(GetResString(IDS_PW_UPL));
	GetDlgItem(IDC_TRAFFIC_TEXT5)->SetWindowText(GetResString(IDS_PW_MAXC));
	GetDlgItem(IDC_TRAFFIC_TEXT13)->SetWindowText(GetResString(IDS_PW_CLIENTPORT));
	GetDlgItem(IDC_AUTOCONNECT)->SetWindowText(GetResString(IDS_PW_AUTOCON));
	GetDlgItem(IDC_RECONN)->SetWindowText(GetResString(IDS_PW_RECON));
	GetDlgItem(IDC_STATIC24)->SetWindowText(GetResString(IDS_PW_SERVER));
	GetDlgItem(IDC_REMOVEDEAD)->SetWindowText(GetResString(IDS_PW_RDEAD));
	GetDlgItem(IDC_STATIC25)->SetWindowText(GetResString(IDS_PW_RETRIES));
	GetDlgItem(IDC_SCORE)->SetWindowText(GetResString(IDS_PW_SCORE));
	GetDlgItem(IDC_UPDATESERVERCONNECT)->SetWindowText(GetResString(IDS_PW_USC));
	GetDlgItem(IDC_UPDATESERVERCLIENT)->SetWindowText(GetResString(IDS_PW_UCC));
	GetDlgItem(IDC_FILTER)->SetWindowText(GetResString(IDS_PW_FILTER));
	GetDlgItem(IDC_AUTOSERVER)->SetWindowText(GetResString(IDS_PW_USS));
	GetDlgItem(IDC_STATIC27)->SetWindowText(GetResString(IDS_PW_MISC));
	GetDlgItem(IDC_MINTRAY)->SetWindowText(GetResString(IDS_PW_TRAY));
	GetDlgItem(IDC_BEEPER)->SetWindowText(GetResString(IDS_PW_BEEP));
	GetDlgItem(IDC_EXIT)->SetWindowText(GetResString(IDS_PW_PROMPT));
	GetDlgItem(IDC_SPLASHON)->SetWindowText(GetResString(IDS_PW_SPLASH));
	GetDlgItem(IDC_DBLCLICK)->SetWindowText(GetResString(IDS_PW_DBLCLICK));
	GetDlgItem(IDC_TRAFFIC_TEXT6)->SetWindowText(GetResString(IDS_PW_TOOL));
	GetDlgItem(IDC_BRINGTOFOREGROUND)->SetWindowText(GetResString(IDS_PW_FRONT));
	GetDlgItem(IDC_LANG)->SetWindowText(GetResString(IDS_PW_LANG));
	GetDlgItem(IDC_STATIC28)->SetWindowText(GetResString(IDS_PW_FILES));
	GetDlgItem(IDC_ICH)->SetWindowText(GetResString(IDS_PW_ICH));
	GetDlgItem(IDC_STATIC29)->SetWindowText(GetResString(IDS_PW_SHARE));
	GetDlgItem(IDC_SEESHARE1)->SetWindowText(GetResString(IDS_PW_EVER));
	GetDlgItem(IDC_SEESHARE2)->SetWindowText(GetResString(IDS_PW_FRIENDS));
	GetDlgItem(IDC_SEESHARE3)->SetWindowText(GetResString(IDS_PW_NOONE));
	GetDlgItem(IDC_BUTTON3)->SetWindowText(GetResString(IDS_PW_RESET));
	GetDlgItem(IDC_APPLY)->SetWindowText(GetResString(IDS_PW_APPLY));
}
