//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#pragma once
#include "afxdlgs.h"
#include "ResizableLib\ResizableDialog.h"
#include "OScopeCtrl.h"
#include "otherfunctions.h"
#include "ColorFrameCtrl.h"

// CStatisticsDlg dialog

class CStatisticsDlg : public CResizableDialog
{
	DECLARE_DYNAMIC(CStatisticsDlg)
public:
	CStatisticsDlg(CWnd* pParent = NULL);   // standard constructor
	virtual ~CStatisticsDlg();
	void Localize();

	void SetCurrentRate(float uploadrate, float downloadrate);
	void ShowInterval(bool setSliderPosition);
	void ShowStatistics();
	void SetARange(bool SetDownload,int maxValue);

// Dialog Data
	enum { IDD = IDD_STATISTICS };
protected:
	//{{AFX_MSG(CSpinToolBar)
	afx_msg void OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar);
	//}}AFX_MSG

    COScopeCtrl m_DownloadOMeter,m_UploadOMeter,m_Statistics;
	CSliderCtrl m_Slider;
	CColorFrameCtrl m_Led1[ 2 ];
	CColorFrameCtrl m_Led2[ 2 ];
	CColorFrameCtrl m_Led3[ 4 ];

	CTreeCtrl stattree;

	CString	m_SliderValue;
	int dl_users,dl_active;
	double m_dPlotDataMore[4];
	int stat_max;

	// tree-folders
	HTREEITEM h_general,h_transfer,h_connection,h_clients,h_servers;
	HTREEITEM h0,h1,h2,h3,h4,h5,h6,h7,h8,h9,h10,h11,h12,h13,h14,h15,h16;

	void SetupLegend( int ResIdx, int ElmtIdx, int legendNr);
	void SetStatsRanges(int min, int max);
	float GetAvgDownloadRate(int averageType);
	float GetAvgUploadRate(int averageType);

	virtual void OnSize(UINT nType,int cx,int cy);
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support	
	DECLARE_MESSAGE_MAP()
	virtual BOOL OnInitDialog(); 
	void	OnShowWindow(BOOL bShow,UINT nStatus);

private:
	const static int AVG_SESSION =0;
};
